/*
hgetblk.c Version 0.2.0  Hash read database block
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void hgetblk(hshhdr,ofst)
hashfmt *hshhdr;
off_t ofst;
   {
   off_t loc;
   int rdlen;
   hshhdr->reason = 0;
   loc = hseek(hshhdr,ofst);
   if (hshhdr->reason) return;
   rdlen = read(hshhdr->hndl,
      (unsigned char *) hshhdr->node,
      hshhdr->rcdnode);
   if (rdlen == hshhdr->rcdnode)
      {
      hshhdr->ofst = ofst;
      hshhdr->rcd = (unsigned char *)
	 hshhdr->node + hshhdr->rcdhdr;
      return;
      } /* good read */
   else if (rdlen < 0)
      {
      fprintf(stderr,"hgetblk: error reading database "
	 "ofst %08x rcdnode %d rdlen %d)\n",
	 (unsigned int) ofst,
	 hshhdr->rcdnode, rdlen);
      fprintf(stderr,"hndl %d loc %08x errno %d\n",
	 hshhdr->hndl,
	 (unsigned int) loc,
	 errno);
      perror("Read error");
      hshhdr->reason = SYS_ERR + errno;
      return;
      } /* read err */
   else
      {
      fprintf(stderr,"hgetblk: error reading database "
	 "ofst %08x rcdnode %d rdlen %d)\n",
	 (unsigned int) ofst,
	 hshhdr->rcdnode, rdlen);
      hshhdr->reason = HASH_ERR + 1301;
      return;
      } /* read err */
   } /* hgetblk */
